commit f431a8300bdb3bb28cc95b140881c329c5ee3d5a
Author: freddy77 <freddy77>
Date:   Thu Oct 23 06:01:37 2008 +0000

    fix some small issues on odbc_tds2sql

diff --git a/ChangeLog b/ChangeLog
index 430e3d0..e68bcd6 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,12 +1,18 @@
-Mon Oct 22 22:15:20 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+Thu Oct 23 08:00:17 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/convert_tds2sql.c:
+	- update correctly sqlgetdatapos
+	- add some comments
+	- destlen is always >= 0 (SQLULEN)
+
+Wed Oct 22 22:15:20 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/convert_tds2sql.c src/odbc/unittests/data.c:
 	- support conversions from wire to SQL_C_WCHAR
 
-Mon Oct 22 17:21:18 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+Wed Oct 22 17:21:18 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/odbc_util.c src/odbc/unittests/data.c:
 	- initial SQL_C_WCHAR support
 
-Mon Oct 22 16:14:20 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+Wed Oct 22 16:14:20 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/data.c: improve
 
 Fri Oct 17 14:20:00 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
@@ -739,4 +745,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2631 2008/10/22 20:16:11 freddy77 Exp $
+$Id: ChangeLog,v 1.2632 2008/10/23 06:01:37 freddy77 Exp $
diff --git a/src/odbc/convert_tds2sql.c b/src/odbc/convert_tds2sql.c
index 34894dd..e1d22aa 100644
--- a/src/odbc/convert_tds2sql.c
+++ b/src/odbc/convert_tds2sql.c
@@ -40,7 +40,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.57 2008/10/22 20:16:11 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.58 2008/10/23 06:01:37 freddy77 Exp $");
 
 #if SIZEOF_SQLWCHAR == 2
 # if WORDS_BIGENDIAN
@@ -200,7 +200,7 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 		}
 
 		nDestSybType = TDS_CONVERT_CHAR;
-		ores.cc.len = destlen >= 0 ? destlen : 0;
+		ores.cc.len = destlen;
 		ores.cc.c = dest;
 	}
 
@@ -214,7 +214,7 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 		tds_strftime(buf, sizeof(buf), srctype == SYBDATETIME ? "%Y-%m-%d %H:%M:%S.%z" : "%Y-%m-%d %H:%M:%S", &when);
 
 		nRetVal = strlen(buf);
-		memcpy(dest, buf, destlen >= 0 ? (destlen < nRetVal ? destlen : nRetVal) : 0);
+		memcpy(dest, buf, destlen < nRetVal ? destlen : nRetVal);
 	} else {
 		nRetVal = tds_convert(context, srctype, src, srclen, nDestSybType, &ores);
 	}
@@ -237,14 +237,12 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 			 * odbc always terminate but do not overwrite 
 			 * destination buffer more than needed
 			 */
-			/* TODO check for source !!! */
-			if (curcol)
-				curcol->column_text_sqlgetdatapos += binary_conversion ? cplen / 2 : cplen;
+			/* update datapos only for binary source (char already handled) */
+			if (curcol && binary_conversion)
+				curcol->column_text_sqlgetdatapos += cplen / 2;
 			dest[cplen] = 0;
 		} else {
 			/* if destlen == 0 we return only length */
-			if (destlen != 0)
-				ret = SQL_NULL_DATA;
 		}
 		break;
 
@@ -263,18 +261,17 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 			 * odbc always terminate but do not overwrite 
 			 * destination buffer more than needed
 			 */
-			/* TODO check for source !!! */
-			if (curcol)
-				curcol->column_text_sqlgetdatapos += binary_conversion ? cplen / 2 : cplen;
+			/* update datapos only for binary source (char already handled) */
+			if (curcol && binary_conversion)
+				curcol->column_text_sqlgetdatapos += cplen / 2;
+			/* convert in place and terminate */
 			wp[cplen] = 0;
-			for (;cplen > 0;) {
+			while (cplen > 0) {
 				--cplen;
 				wp[cplen] = p[cplen];
 			}
 		} else {
 			/* if destlen == 0 we return only length */
-			if (destlen != 0)
-				ret = SQL_NULL_DATA;
 		}
 		break;
 

